Subject: Provide an interface to query blocks/hashmaps

Description

When uploading a file with its hashmap, you may need to read the file twice - one to create the hashmap and one to send the data. To

avoid this, investigate an interface for querying blocks, so the client software can upload blocks and create the hashmap in one step.

History

#1 - 01/19/2012 06:10 pm - Antony Chazapis

- Target version deleted (1.0.0)

This has been opened mainly for discussion.

The interface provided now, assures the least communication with the server:

    -  Request an object with the provided hashes

    -  Upload any missing hashes

    -  Request the object again

If this is converted to:

    -  For each block:

    -  Check if the block is on the server

    -  Upload if not there

    -  Request an object with the provided hashes

Then, for a very large object, the process may impose a great load on the server. Sure, a bad client software can flood the server with requests, but this

can not be the "suggested" method.

Moreover:

    -  We expect that most of the blocks will be online after some time.

    -  We expect that client hardware has an excess of available computing power, while we should minimize the server load as much as possible. For

objects up to a few hundred MB, it should be trivial for modern hardware to retrieve and process data.

So for small files, the current method seems best. For large files - like a 10GB vm system image, uploading with one request per 4MB block will require

thousands of requests.

This is one opinion. Will leave it as is, except if new findings suggest a change is necessary.

#2 - 04/13/2012 09:38 am - Antony Chazapis

- Status changed from New to Feedback

- Target version set to 1.0.0

#3 - 02/08/2013 06:50 pm - Vangelis Koukis

- Project changed from Pithos to Synnefo

- Target version deleted (1.0.0)

#4 - 02/08/2013 06:52 pm - Vangelis Koukis
- Category set to Pithos

#5 - 04/09/2013 11:10 am - Georgios Tsoukalas

- Status changed from Feedback to Closed
